=== debian/changelog ===
openttd-opengfx (7.1-1) unstable; urgency=medium

  * [a27034b] Update watch file
  * [d2bc84d] Bump standards version to 4.6.0 (no changes required)
  * [4b07af7] Add upstream metadata
  * [3a4714f] New upstream release 7.1
  * [32090a7] Revert "Add patch to fix documentation filenames"
  * [a5618ad] Remove broken-symlink lintian override

 -- Matthijs Kooijman <matthijs@stdin.nl>  Tue, 23 Nov 2021 14:00:03 +0100
