=== debian/control ===
Source: openttd-opengfx
Section: games
Priority: optional
Maintainer: Matthijs Kooijman <matthijs@stdin.nl>
Uploaders: Jordi Mallach <jordi@debian.org>
Build-Depends: debhelper-compat (= 13), nml (>= 0.3.0), gimp, grfcodec, python3
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/openttd-team/openttd-opengfx
Vcs-Git: https://salsa.debian.org/openttd-team/openttd-opengfx.git
Homepage: https://github.com/OpenTTD/OpenGFX
Rules-Requires-Root: no

Package: openttd-opengfx
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: free graphics set for use with the OpenTTD game
 OpenGFX is a graphics set for the OpenTTD game that has been built from
 scratch under an open license. It allows the OpenTTD game to be played without
 needing the graphics files from the original Transport Tycoon Deluxe game.
